module Poly ( 
     Poly , 
     maxGrado,
     grado,
     (*^),
     coef,
     val
{--
instance  Eq a => Eq (Poly a)
instance (Num a) => Num (Poly a) 
  no define (*)
instance (Show a, Num a) => Show (Poly a)
--}
       ) where 

import Array

maxGrado :: Int -- Maximo grado posible
grado :: Num a => Poly a -> Int -- Devuelve el grado de un polinomio
(*^) :: Num a => a -> Int -> Poly a -- Constructor de terminos
coef :: Num a => Int -> Poly a -> a -- Devuelve el coeficiente
val :: Num a => Poly a -> a -> a -- evalua el polinomio en el valor

infix 8 *^


-- *********************************************************************** --

maxGrado = 10

tam = maxGrado + 1

data Num a => Poly a = MkPoly (Array Int a) deriving Eq

cero :: Num a => Poly a
cero = MkPoly (listArray (0,maxGrado) (replicate  tam 0))

xPow :: Num a => Int -> a -> Poly a
xPow i a = MkPoly (cero' // [(i,a)])
    where
      MkPoly cero' = cero

(*^) = flip xPow

coef i (MkPoly arr) = (arr!i)
  
grado (MkPoly arr) = foldl f 0 (indices arr)
    where
      f a i = if (arr!i /= 0) then i else a 

tabulate :: Ix a => (a,a) -> (a -> b) -> [b]
tabulate ixs f = map f (range ixs) 

binOper :: (Num a, Num b, Num c) => 
           (a -> b -> c) -> Poly a -> Poly b -> Poly c
binOper op (MkPoly a) (MkPoly b) =
    MkPoly (listArray (0,maxGrado) (tabulate (0,maxGrado) f))
        where
          f i = op (a!i) (b!i)

instance (Num a) => Num (Poly a) where
    (+) = binOper (+)
    (-) = binOper (-)
    fromInteger n = (fromInteger n) *^ 0

intercal :: a -> [a] -> [a]
intercal _ [] = []
intercal a [x] = [x]
intercal a (x:xs) = x:a:(intercal a xs) 

instance (Show a, Num a) => Show (Poly a) where
    show (MkPoly arr) = concat (intercal " + " (map show' (filt arr)))
        where
          filter0 = assocs 
          isCero = (==0) . snd
          filter1 = filter ((/= 0) . snd) 
          filter2 = \ x -> if (length x == 0 ) then [(0,0)] else x
          show' (0,0) = "0"
          show' (0,c) = show c
          show' (1,1) = "x"
          show' (1,c) = show c ++ "x"
          show' (i,1) = "x^" ++ show i 
          show' (i,c) = show c ++ " * x^" ++ show i 
          filt = filter2 . filter1 . filter0

